routes/admin.php
<?php

use App\Http\Controllers\Admin\DashboardController;
use App\Http\Controllers\Admin\ProfileController;
use App\Http\Controllers\Admin\UserController;
use App\Http\Controllers\Admin\RoleController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Admin Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web,verified,is_admin" middleware group and "admin." name.
| Now create something great!
|
*/

Route::get('dashboard', [DashboardController::class,'index'])->name('dashboard');

Route::resource('users', UserController::class);

Route::post('add-roles/{role}',[RoleController::class,'addRolesToAdmins']);
Route::resource('roles', RoleController::class);

Route::resource('profile', ProfileController::class)->parameters([
    'profile' => 'user'
])->only(['show','edit','update'])->middleware('me');

routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::get('/dashboard', function () {
    return view('dashboard');
})->middleware(['auth'])->name('dashboard');

require __DIR__.'/auth.php';

app/Models/Role.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;

class Role extends Model
{
    use HasFactory;

    protected $fillable = [
        'title' , 'fa_title'
    ];

    public function users() : BelongsToMany
    {
        return $this->belongsToMany(User::class);
    }

    public function permissions() : BelongsToMany
    {
        return $this->belongsToMany(Permission::class);
    }

    public function scopeFilter($query,Array $request)
    {
        $request = collect($request);

        if($request->get('search'))
            $query->where('title','like','%'.$request->get('search').'%')->orWhere('fa_title','like','%'.$request->get('search').'%');

        return $query;
    }

}

app/Http/Controllers/Admin/RoleController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Permission;
use App\Models\Role;
use App\Models\User;
use Illuminate\Http\Request;

class RoleController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $this->authorize('viewAny',Role::class);

        $roles = Role::with(['users','permissions'])->filter(['search' => $request->search])->latest()->paginate(12)->withQueryString();
        $admins = User::where('level','admin')->get();
        return view('admin.roles.index',compact('roles','admins'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $this->authorize('create',Role::class);

        $permissions = Permission::all();
        return view('admin.roles.create',compact('permissions'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->authorize('create',Role::class);

        $request->validate([
            'title' => 'required|string|max:255|unique:roles,title',
            'fa_title' => 'required|string|max:255',
            //'permissions' => 'required|array|min:1',
        ]);

        $role = Role::create([
            'fa_title' => $request->input('fa_title'),
            'title' => $request->input('title'),
        ]);

        $role->permissions()->attach($request->input('permissions'));

        return back()->with('success', 'نقش با موفقیت ایجاد شد.');;

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Role $role)
    {
        $this->authorize('update',Role::class);

        $permissions = Permission::all();
        return view('admin.roles.edit',compact('role','permissions'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Role $role)
    {
        $this->authorize('update',Role::class);

        $request->validate([
            'title' => 'required|string|max:255',
            'fa_title' => 'required|string|max:255',
            //'permissions' => 'required|array|min:1',
        ]);

        $role->update([
            'fa_title' => $request->input('fa_title'),
            'title' => $request->input('title'),
        ]);

        $role->permissions()->sync($request->input('permissions'));

        return back()->with('success', 'نقش با موفقیت ویرایش شد.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Role $role)
    {
        $this->authorize('delete',Role::class);

        $role->permissions()->detach();
        $role->delete();

        return back();
    }

    public function addRolesToAdmins(Request $request,Role $role)
    {
        $this->authorize('change',Role::class);

        $role->users()->sync($request->input('admins'));

        return back()->with('success', ' با موفقیت انجام شد.');
    }
}

resources/views/admin/roles/create.blade.php
<x-admin.layouts>

    <div class="row">
        <div class="col-md-12">
            <div class="card stacked-form">
                <div class="card-header ">
                    <h4 class="card-title">افزودن نقش جدید</h4>
                </div>
                <div class="card-body ">
                    <form method="POST" action="{{ route('admin.roles.store') }}" enctype="multipart/form-data">
                        @csrf
                        <div class="form-row">
                            <div class="form-group col-md-6 @error('fa_title') has-error @enderror">
                                <label>عنوان فارسی</label>
                                <input type="text" name="fa_title" class="form-control" value="{{ old('fa_title') }}">
                                @error('fa_title')
                                    <label class="error" for="fa_title">{{ $message }}</label>
                                @enderror
                            </div>
                            <div class="form-group col-md-6 @error('title') has-error @enderror">
                                <label>عنوان انگلیسی</label>
                                <input type="text" name="title" class="form-control" value="{{ old('title') }}">
                                @error('title')
                                    <label class="error" for="title">{{ $message }}</label>
                                @enderror
                            </div>
                        </div>

                        <div class="form-group @error('permissions') has-error @enderror">
                            <label>رمز عبور</label>

                            <div class="d-flex justify-content-start align-items-center">
                                @foreach ($permissions as $permission)
                                <div class="custom-control custom-checkbox m-2">
                                    <input name="permissions[]" value="{{ $permission->id }}" type="checkbox" class="custom-control-input" id="permission-{{ $permission->id }}">
                                    <label class="custom-control-label" for="permission-{{ $permission->id }}">{{ $permission->fa_title }}</label>
                                </div>
                                @endforeach
                            </div>

                            @error('permissions')
                                <label class="error" for="name">{{ $message }}</label>
                            @enderror
                        </div>

                        <div class="form-group">
                            <button type="submit" class="btn btn-fill btn-info">ثبت</button>
                        </div>
                    </form>
                </div>

            </div>
        </div>
        @push('scripts')
            @if (session()->has('success'))
            <script>
                swal("پیام موفقیت!", "{{ session('success') }}", "success")
            </script>
            @endif
        @endpush
    </div>
</x-admin.layouts>

resources/views/admin/roles/edit.blade.php
<x-admin.layouts>

    <div class="row">
        <div class="col-md-12">
            <div class="card stacked-form">
                <div class="card-header ">
                    <h4 class="card-title">ویرایش نقش {{ $role->fa_title }}</h4>
                </div>
                <div class="card-body ">
                    <form method="POST" action="{{ route('admin.roles.update',$role) }}" enctype="multipart/form-data">
                        @csrf
                        @method('patch')
                        <div class="form-row">
                            <div class="form-group col-md-6 @error('fa_title') has-error @enderror">
                                <label>عنوان فارسی</label>
                                <input type="text" name="fa_title" class="form-control" value="{{ $role->fa_title }}">
                                @error('fa_title')
                                    <label class="error" for="fa_title">{{ $message }}</label>
                                @enderror
                            </div>
                            <div class="form-group col-md-6 @error('title') has-error @enderror">
                                <label>عنوان انگلیسی</label>
                                <input type="text" name="title" class="form-control" value="{{ $role->title }}">
                                @error('title')
                                    <label class="error" for="title">{{ $message }}</label>
                                @enderror
                            </div>
                        </div>

                        <div class="form-group @error('permissions') has-error @enderror">
                            <label>رمز عبور</label>

                            <div class="d-flex justify-content-start align-items-center">
                                @foreach ($permissions as $permission)
                                <div class="custom-control custom-checkbox m-2">
                                    <input name="permissions[]" value="{{ $permission->id }}" {{ $role->permissions->contains($permission) ? 'checked' : '' }} type="checkbox" class="custom-control-input" id="permission-{{ $permission->id }}">
                                    <label class="custom-control-label" for="permission-{{ $permission->id }}">{{ $permission->fa_title }}</label>
                                </div>
                                @endforeach
                            </div>

                            @error('permissions')
                                <label class="error" for="name">{{ $message }}</label>
                            @enderror
                        </div>

                        <div class="form-group">
                            <button type="submit" class="btn btn-fill btn-info">ثبت</button>
                        </div>
                    </form>
                </div>

            </div>
            @push('scripts')
                @if (session()->has('success'))
                <script>
                    swal("پیام موفقیت!", "{{ session('success') }}", "success")
                </script>
                @endif
            @endpush
        </div>
    </div>
</x-admin.layouts>

resources/views/admin/roles/index.blade.php
<x-admin.layouts>
    <div class="row">
        <div class="col-md-6">
            <h4 class="card-title">لیست نقش ها</h4>
        </div>
    </div>
    <div class="row">
        <div class="col-md-12">
            <div class="card table-with-switches">
                <div class="card-header ">
                    <div class="d-flex justify-content-between align-items-center">
                        <div>
                            @can('create',App\Models\Role::class)
                                <a class="btn btn-info" href="{{ route('admin.roles.create') }}">افزودن نقش جدید</a>
                            @endcan
                        </div>
                        <div>
                            <form action="{{ route('admin.roles.index') }}" method="get" class="position-relative">
                                <input type="name" value="{{ request('search') }}" name="search" class="form-control form-control-sm" placeholder="جستجو...">
                                @if (request('search'))
                                <a href="{{ route('admin.roles.index') }}" style="position: absolute;top: 8px;left: 10px;">x</a>
                                @endif
                            </form>
                        </div>
                    </div>
                </div>
                <div class="card-body table-full-width">
                    @if ($roles->isEmpty())
                        <div class="col">
                            <div class="alert alert-info" role="alert">
                                موردی برای نمایش وجود ندارد.
                            </div>
                        </div>
                    @else
                        <table class="table table-striped">
                            <thead>
                                <tr>
                                    <th>نقش</th>
                                    <th>دسترسی ها</th>
                                    <th>کاربران</th>
                                    @canany(['create','delete','change'],App\Models\Role::class)
                                    <th></th>
                                    @endcanany
                                </tr>
                            </thead>
                            <tbody>
                                @foreach ($roles as $role)
                                <tr>
                                    <td>{{ $role->fa_title }} ({{ $role->title }})</td>
                                    <td style="max-width: 400px;">
                                        @foreach ($role->permissions as $premission)
                                            <span class="badge p-2 badge-info mb-1">
                                                {{ $premission->fa_title }}
                                            </span>
                                        @endforeach
                                    </td>
                                    <td style="max-width: 400px;">
                                        @foreach ($role->users as $user)
                                            <a href="{{ route('admin.users.show',$user) }}" class="badge p-2 badge-secondary mb-1">
                                                {{ $user->email }}
                                            </a>
                                        @endforeach
                                    </td>
                                    <td class="text-right">
                                        <form action="{{route('admin.roles.destroy',$role->id)}}" method="post">
                                            @csrf
                                            @method('delete')
                                            @can('update',App\Models\Role::class)
                                            <a href="{{ route('admin.roles.edit',$role->id) }}" class="btn btn-primary btn-sm">ویرایش<i class="icon-pencil"></i></a>
                                            @endcan
                                            @can('change',App\Models\Role::class)
                                            <span type="button" class="btn btn-secondary btn-sm" data-toggle="modal" data-target="#add-admin" data-role="{{ json_encode($role) }}">افزودن ادمین</span>
                                            @endcan
                                            @can('delete',App\Models\Role::class)
                                            <button class="btn btn-danger btn-sm" id="delete-item-{{ $role->id }}"><i class="icon-trash-o "></i>حذف</button>
                                            @push('scripts')
                                            <script>
                                                $("#delete-item-{{ $role->id }}").on('click', function (event) {
                                                    event.preventDefault();
                                                    var self = $(this);
                                                    swal({
                                                        title: "مطمئنی؟",
                                                        text: "",
                                                        type: "warning",
                                                        showCancelButton: true,
                                                        confirmButtonClass: "btn btn-info btn-fill",
                                                        confirmButtonText: "آره",
                                                        cancelButtonText: "انصراف",
                                                        cancelButtonClass: "btn btn-danger btn-fill",
                                                        closeOnConfirm: false,
                                                    }, function() {
                                                        self.parents('form:first').submit();
                                                        swal("موفق!", "با موفقیت حذف شد.", "success");
                                                    });
                                                });
                                            </script>
                                        @endpush
                                            @endcan
                                        </form>
                                    </td>
                                </tr>
                                @endforeach
                            </tbody>
                        </table>
                        <div class="d-flex justify-content-center align-items-center">
                        {{ $roles->links() }}
                        </div>
                        <div class="modal fade" id="add-admin" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
                            <div class="modal-dialog modal-lg">
                                <div class="modal-content">
                                    <div class="modal-header">
                                        <h5 class="modal-title" id="exampleModalLabel"></h5>
                                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                            <span aria-hidden="true">&times;</span>
                                        </button>
                                    </div>
                                    <div class="modal-body">
                                        <form method="POST">
                                            @csrf
                                            @method("post")
                                            <div class="form-group">
                                                <label for="recipient-name" class="col-form-label">ادمین ها:</label>
                                                <div class="d-flex justify-content-start align-items-center">
                                                    @foreach ($admins as $admin)
                                                    <div class="custom-control custom-checkbox m-2">
                                                        <input name="admins[]" value="{{ $admin->id }}" type="checkbox" class="custom-control-input" id="admin-{{ $admin->id }}">
                                                        <label class="custom-control-label" for="admin-{{ $admin->id }}">{{ $admin->email }} ({{ $admin->name }})</label>
                                                    </div>
                                                    @endforeach
                                                </div>
                                            </div>

                                            <div class="modal-footer px-0">
                                                <button type="button" class="btn btn-secondary" data-dismiss="modal">انصراف</button>
                                                <button type="submit" class="btn btn-primary">ثبت</button>
                                            </div>
                                        </form>
                                    </div>
                                </div>
                            </div>
                        </div>

                        @push('scripts')
                            <script>
                                $('#add-admin').on('show.bs.modal', function (event) {
                                    var button = $(event.relatedTarget) // Button that triggered the modal
                                    var role = button.data('role') // Extract info from data-* attributes
                                    // If necessary, you could initiate an AJAX request here (and then do the updating in a callback).
                                    // Update the modal's content. We'll use jQuery here, but you could use a data binding library or other methods instead.
                                    var modal = $(this)
                                    modal.find('.modal-title').text(' افزودن نقش ' + role.title + ' به ادمین ها ');
                                    modal.find('form').attr("action",`/admin/add-roles/${role.id}`);

                                    const checkbox = modal.find("input[type=checkbox]");
                                    checkbox.map((key,item) => {item.checked = false;});

                                    let users = role.users.map(item => item.id);

                                    checkbox.map((key,item) => {

                                        if(users.includes(parseInt(item.value)))
                                        {
                                            item.checked = true;
                                        }
                                    });

                                });

                            </script>

                            @if (session()->has('success'))
                            <script>
                                swal("پیام موفقیت!", "{{ session('success') }}", "success")
                            </script>
                            @endif
                        @endpush

                    @endif

                </div>
            </div>
        </div>
    </div>
</x-admin.layouts>